diff -bruN freeswan-1.9.orig/pluto/connections.c freeswan-1.9/pluto/connections.c
--- freeswan-1.9.orig/pluto/connections.c	Sun Jan 28 16:03:02 2001
+++ freeswan-1.9/pluto/connections.c	Wed Jun  6 16:37:02 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: connections.c,v 1.82 2001/01/28 21:03:02 dhr Exp $
+ * RCSID $Id: connections.c,v 1.103 2001/06/02 06:42:22 dhr Exp $
  */
 
 #include <string.h>
@@ -21,6 +21,7 @@
 #include <unistd.h>
 #include <netinet/in.h>
 #include <sys/socket.h>
+#include <sys/stat.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 
@@ -36,35 +37,45 @@
 #include "timer.h"
 #include "ipsec_doi.h"	/* needs demux.h and state.h */
 #include "server.h"
-#include "kernel.h"	/* for no_klips */
+#include "kernel.h"
 #include "log.h"
 #include "preshared.h"
 #include "dnskey.h"	/* needs preshared.h */
 #include "whack.h"
 
+#ifdef OPENSSL
+#include "openssl.h"
+#include "xmap.h"
+#endif
+static void flush_pending_by_connection(struct connection *c); /* forward */
+
 static struct connection *connections = NULL;
 
-/* host_pair: a nexus of information about a pair of hosts.
+/* struct host_pair: a nexus of information about a pair of hosts.
  * A host is an IP address, UDP port pair.  This is a debatable choice:
  * - should port be considered (no choice of port in standard)?
  * - should ID be considered (hard because not always known)?
  * - should IP address matter on our end (we don't know our end)?
- * Since connections are not all oriented, the host identifiers
- * (ip_address values) are placed in a canonical order.
+ * Only oriented connections are registered.
+ * Unoriented connections are kept on the unoriented_connections
+ * linked list (using hp_next).  For them, host_pair is NULL.
  */
 
 struct host_pair {
     struct {
 	ip_address addr;
 	u_int16_t port;	/* host order */
-    } a, b;
+    } me, him;
     bool initial_connection_sent;
     struct connection *connections;	/* connections with this pair */
+    struct pending *pending;   /* awaiting Keying Channel */
     struct host_pair *next;
 };
 
 static struct host_pair *host_pairs = NULL;
 
+static struct connection *unoriented_connections = NULL;
+
 /* check to see that Ids of peers match */
 bool
 same_peer_ids(const struct connection *c, const struct connection *d
@@ -74,58 +85,20 @@
 	&& same_id(his_id == NULL? &c->that.id : his_id, &d->that.id);
 }
 
-/* Arbitrary canonicalization of host pair.
- * Because it is arbitrary, we don't need to compare in host order.
- */
-static void
-canonical_host_pair(struct host_pair *hp
-, const ip_address *xaddr, u_int16_t xport
-, const ip_address *yaddr, u_int16_t yport)
-{
-    int ac;
-
-    passert(sameaddrtype(xaddr, yaddr));
-    ac = addrcmp(xaddr, yaddr);
-
-    if (ac < 0
-    || (ac == 0 && xport <= yport))
-    {
-	hp->a.addr = *xaddr;
-	hp->a.port = xport;
-	hp->b.addr = *yaddr;
-	hp->b.port = yport;
-    }
-    else
-    {
-	hp->a.addr = *yaddr;
-	hp->a.port = yport;
-	hp->b.addr = *xaddr;
-	hp->b.port = xport;
-    }
-
-    return;
-}
-
 static struct host_pair *
-find_host_pair(const ip_address *xaddr, u_int16_t xport
-, const ip_address *yaddr, u_int16_t yport)
+find_host_pair(const ip_address *myaddr, u_int16_t myport
+, const ip_address *hisaddr, u_int16_t hisport)
 {
-    struct host_pair hp;
     struct host_pair *p, *prev;
-    ip_address any;
 
-    if (yaddr == NULL)
-    {
-	(void) anyaddr(addrtypeof(xaddr), &any);
-	yaddr = &any;
-    }
-
-    canonical_host_pair(&hp, xaddr, xport, yaddr, yport);
+    /* default hisaddr to an appropriate any */
+    if (hisaddr == NULL)
+       hisaddr = aftoinfo(addrtypeof(myaddr))->any;
 
     for (prev = NULL, p = host_pairs; p != NULL; prev = p, p = p->next)
     {
-	if (sameaddr(&p->a.addr, &hp.a.addr) && p->a.port == hp.a.port
-	&& sameaddr(&p->b.addr, &hp.b.addr) && p->b.port == hp.b.port)
+        if (sameaddr(&p->me.addr, myaddr) && p->me.port == myport
+        && sameaddr(&p->him.addr, hisaddr) && p->him.port == hisport)
 	{
 	    if (prev != NULL)
 	    {
@@ -139,11 +112,12 @@
     return p;
 }
 
+/* find head of list of connections with this pair of hosts */
 static struct connection *
-find_host_pair_connections(const ip_address *xaddr, u_int16_t xport
-, const ip_address *yaddr, u_int16_t yport)
+find_host_pair_connections(const ip_address *myaddr, u_int16_t myport
+, const ip_address *hisaddr, u_int16_t hisport)
 {
-    struct host_pair *hp = find_host_pair(xaddr, xport, yaddr, yport);
+    struct host_pair *hp = find_host_pair(myaddr, myport, hisaddr, hisport);
 
     return hp == NULL? NULL : hp->connections;
 }
@@ -151,22 +125,38 @@
 static void
 connect_to_host_pair(struct connection *c)
 {
+    if (oriented(*c))
+    {
     struct host_pair *hp = find_host_pair(&c->this.host_addr, c->this.host_port
 	, &c->that.host_addr, c->that.host_port);
 
     if (hp == NULL)
     {
+	  /* no suitable host_pair -- build one */
 	hp = alloc_thing(struct host_pair, "host_pair");
-	canonical_host_pair(hp, &c->this.host_addr, c->this.host_port
-	    , &c->that.host_addr, c->that.host_port);
+	  hp->me.addr = c->this.host_addr;
+	  hp->me.port = c->this.host_port;
+	  hp->him.addr = c->that.host_addr;
+	  hp->him.port = c->that.host_port;
 	hp->initial_connection_sent = FALSE;
 	hp->connections = NULL;
+	  hp->pending = NULL;
 	hp->next = host_pairs;
 	host_pairs = hp;
     }
     c->host_pair = hp;
     c->hp_next = hp->connections;
     hp->connections = c;
+    }
+    else
+    {
+	/* since this connection isn't oriented, we place it
+	* in the unoriented_connections list instead.
+	*/
+	c->host_pair = NULL;
+	c->hp_next = unoriented_connections;
+	unoriented_connections = c;
+    }
 }
 
 /* figure out if Opportunism is possible: are there any connections
@@ -194,43 +184,41 @@
 	    struct connection *c = find_host_pair_connections(&p->addr
 		, pluto_port, (ip_address *)NULL, pluto_port);
 
-	    for (; c != NULL; c = c->next)
-	    {
-		if (c->rw_state == rwcs_permanent && HasWildcardClient(c))
-		{
-		    passert(HasWildcardIP(*c));
+	    for (; c != NULL; c = c->hp_next)
+		if (c->kind == CK_TEMPLATE && HasWildcardClient(c))
 		    return definitely_some_oppo = possibly_some_oppo = TRUE;
 		}
-	    }
-	}
 	definitely_some_oppo = possibly_some_oppo = FALSE;
     }
     return definitely_some_oppo;
 }
 
 /* find a connection by name.
- * move the winner (if any) to the front.
- * If none is found, and wfd is not NULL_FD, a diagnostic is logged to whack.
+ * If strict, don't accept a CK_INSTANCE.
+ * Move the winner (if any) to the front.
+ * If none is found, and strict, a diagnostic is logged to whack.
  */
 struct connection *
 con_by_name(const char *nm, bool strict)
 {
     struct connection *p, *prev;
 
-    for (prev = NULL, p = connections; ; prev = p, p = p->next)
+    for (prev = NULL, p = connections; ; prev = p, p = p->ac_next)
     {
 	if (p == NULL)
 	{
 	    if (strict)
-		whack_log(RC_UNKNOWN_NAME, "no connection with that name");
+		whack_log(RC_UNKNOWN_NAME
+		    , "no connection named \"%s\"", nm);
 	    break;
 	}
-	if (streq(p->name, nm))
+	if (streq(p->name, nm)
+	&& (!strict || p->kind != CK_INSTANCE))
 	{
 	    if (prev != NULL)
 	    {
-		prev->next = p->next;	/* remove p from list */
-		p->next = connections;	/* and stick it on front */
+		prev->ac_next = p->ac_next;	/* remove p from list */
+		p->ac_next = connections;	/* and stick it on front */
 		connections = p;
 	    }
 	    break;
@@ -240,21 +228,21 @@
 }
 
 void
-unorient_connection(struct connection *c)
+release_connection(struct connection *c)
 {
-    if (c->rw_state == rwcs_instance)
+    if (c->kind == CK_INSTANCE)
     {
 	/* This does everything we need.
-	 * Note that we will be called by delete_connection,
-	 * but rw_state will be rwcs_going_away.
+	 * Note that we will be called recursively by delete_connection,
+	 * but kind will be CK_GOING_AWAY.
 	 */
 	delete_connection(c);
     }
     else
     {
+	flush_pending_by_connection(c);
 	delete_states_by_connection(c);
 	unroute_connection(c);
-	c->interface = NULL;
     }
 }
 
@@ -282,25 +270,44 @@
     /* Must be careful to avoid circularity:
      * we mark c as going away so it won't get deleted recursively.
      */
-    passert(c->rw_state != rwcs_going_away);
-    if (c->rw_state == rwcs_instance)
+    passert(c->kind != CK_GOING_AWAY);
+    if (c->kind == CK_INSTANCE)
     {
-	log("deleting connection \"%s\" with Road Warrior %s"
+	log("deleting connection \"%s\" instance with peer %s"
 	    , c->name, ip_str(&c->that.host_addr));
-	c->rw_state = rwcs_going_away;
+	c->kind = CK_GOING_AWAY;
     }
     else
     {
 	definitely_some_oppo = FALSE;	/* could be more careful */
 	log("deleting connection");
     }
-    unorient_connection(c);	/* won't delete c */
+    release_connection(c);     /* won't delete c */
+
+#ifdef OPENSSL
+    if (c->cert != NULL) X509_free((X509 *)(c->cert));
+    if (c->key != NULL) EVP_PKEY_free((EVP_PKEY *)(c->key));
+    if (c->lu != NULL) sk_XMAP_pop_free(c->lu, XMAP_free);
+    {
+      int i;
+
+      for (i=0; i<MAX_OTHER; i++)
+       if (c->other[i].cert != NULL) {
+         X509_free((X509 *)(c->other[i].cert));
+        }
+    }
+#endif
 
     /* find and delete c from connections list */
-    list_rm(struct connection, next, c, connections);
+    list_rm(struct connection, ac_next, c, connections);
     cur_connection = old_cur_connection;
 
     /* find and delete c from the host pair list */
+    if (c->host_pair == NULL)
+    {
+       list_rm(struct connection, hp_next, c, unoriented_connections);
+    }
+    else
     {
 	struct host_pair *hp = c->host_pair;
 
@@ -311,8 +318,10 @@
 	 * and we haven't even made an initial contact, let's delete
 	 * this guy in case we were created by an attempted DOS attack.
 	 */
-	if (hp->connections == NULL && !hp->initial_connection_sent)
+	if (hp->connections == NULL
+	&& !hp->initial_connection_sent)
 	{
+	    passert(hp->pending == NULL);       /* ??? must deal with this! */
 	    list_rm(struct host_pair, next, hp, host_pairs);
 	    pfree(hp);
 	}
@@ -337,16 +346,103 @@
 }
 
 void
-release_interface(struct iface *i)
+release_dead_interfaces(void)
 {
-    struct connection *c, *n;
+    struct host_pair *hp;
+
+    for (hp = host_pairs; hp != NULL; hp = hp->next)
+    {
+       struct connection **pp
+           , *p;
 
-    passert(i != NULL);
-    for (c = connections; c != NULL; c = n)
+       for (pp = &hp->connections; (p = *pp) != NULL; )
+       {
+           if (p->interface->change == IFN_DELETE)
     {
-	n = c->next;
-	if (c->interface == i)
-	    unorient_connection(c);	/* may delete c */
+               /* this connection's interface is going away:
+                * this connection needs to be relegated to the
+                * unoriented_connections lists
+                */
+               *pp = p->hp_next;       /* advance *pp */
+
+               p->interface = NULL;
+               p->host_pair = NULL;
+               p->hp_next = unoriented_connections;
+               unoriented_connections = p;
+
+               /* do the release last because it leave p dangling */
+               release_connection(p);
+           }
+           else
+           {
+               pp = &p->hp_next;       /* advance pp */
+           }
+       }
+    }
+}
+
+/* adjust orientations of connections to reflect newly added interfaces */
+void
+check_orientations(void)
+{
+    /* try to orient all the unoriented connections */
+    {
+       struct connection *c = unoriented_connections;
+
+       unoriented_connections = NULL;
+
+       while (c != NULL)
+       {
+           struct connection *nxt = c->hp_next;
+
+           (void)orient(c);
+           connect_to_host_pair(c);
+           c = nxt;
+       }
+    }
+
+    /* Check that no oriented connection has become double-oriented.
+     * In other words, the far side must not match one of our new interfaces.
+     */
+    {
+       struct iface *i;
+
+       for (i = interfaces; i != NULL; i = i->next)
+       {
+           if (i->change == IFN_ADD)
+           {
+               struct host_pair *hp;
+
+               for (hp = host_pairs; hp != NULL; hp = hp->next)
+               {
+                   if (sameaddr(&hp->him.addr, &i->addr)
+                   && (!no_klips || hp->him.port == pluto_port))
+                   {
+                       /* bad news: the whole chain of connections
+                        * hanging off this host pair has both sides
+                        * matching an interface.
+                        * We'll get rid of them, using orient and
+                        * connect_to_host_pair.  But we'll be lazy
+                        * and not ditch the host_pair itself (the
+                        * cost of leaving it is slight and cannot
+                        * be induced by a foe).
+                        */
+                       struct connection *c = hp->connections;
+
+                       hp->connections = NULL;
+                       while (c != NULL)
+                       {
+                           struct connection *nxt = c->hp_next;
+
+                           c->interface = NULL;
+                           (void)orient(c);
+                           connect_to_host_pair(c);
+                           c = nxt;
+                       }
+                   }
+               }
+           }
+       }
     }
 }
 
@@ -429,7 +525,7 @@
     /* id, if different from host */
     host_id[0] = '\0';
     if (!(this->id.kind == ID_NONE
-    || ((this->id.kind == ID_IPV4_ADDR || this->id.kind == ID_IPV6_ADDR) && sameaddr(&this->id.ip_addr, &this->host_addr))))
+    || (id_is_ipaddr(&this->id) && sameaddr(&this->id.ip_addr, &this->host_addr))))
     {
 	int len = idtoa(&this->id, host_id+1, sizeof(host_id)-2);
 
@@ -462,12 +558,61 @@
 static void
 unshare_connection_strings(struct connection *c)
 {
+#ifdef OPENSSL
+    void *tempcert, *tempkey;
+    STACK_OF(XMAP) *templu;
+#endif
     c->name = clone_str(c->name, "connection name");
 
     unshare_id_content(&c->this.id);
     c->this.updown = clone_str(c->this.updown, "updown");
     unshare_id_content(&c->that.id);
     c->that.updown = clone_str(c->that.updown, "updown");
+
+#ifdef OPENSSL
+    {
+      int i;
+
+      for (i=0; i<MAX_OTHER; i++)
+        if (c->other[i].cert) {
+          tempcert = c->other[i].cert;
+          c->other[i].cert = X509_dup(tempcert);
+        }
+    }
+
+
+    if (c->cert) {
+      tempcert = c->cert;
+      c->cert = X509_dup(tempcert);
+    }
+/* ******** HOW to use EVP_PKEY *************
+ * #define RSAPrivateKey_dup(rsa) (RSA *)ASN1_dup((int (*)())i2d_RSAPrivateKey,
+ *                (char *(*)())d2i_RSAPrivateKey,(char *)rsa)
+ * /usr/include/openssl/evp.h:621:RSA *  EVP_PKEY_get1_RSA(EVP_PKEY *pkey);
+ *
+ * DEFS:
+ * /usr/include/openssl/evp.h:637:EVP_PKEY *  d2i_PrivateKey(int type,
+ *               EVP_PKEY **a, unsigned char **pp,
+ * /usr/include/openssl/evp.h:641:int  i2d_PrivateKey(EVP_PKEY *a,
+ *               unsigned char **pp);
+ * X509 dup macro:
+ * #define X509_dup(x509) (X509 *)ASN1_dup((int (*)())i2d_X509, \
+ *                 (char *(*)())d2i_X509,(char *)x509)
+ * NEW MACRO:
+ * #define EVP_PKEY_dup(pkey) \
+ *   (EVP_PKEY *)ASN1_dup((int (*)())i2d_PrivateKey, \
+ *   (char *(*)())d2i_AutoPrivateKey,(char *)pkey)
+ */
+
+    if (c->key) {
+      tempkey = c->key;
+      c->key = EVP_PKEY_dup(tempkey);
+    }
+    if (c->lu) {
+      templu = c->lu;
+      c->lu = clone_sk_XMAP(templu);
+    }
+#endif
 }
 
 static void
@@ -537,7 +682,11 @@
 
 	    for (; c != NULL; c = c->hp_next)
 	    {
+#ifndef OPENSSL
 		if ((c->policy ^ wm->policy) & (POLICY_PSK | POLICY_RSASIG))
+#else
+		if ((c->policy ^ wm->policy) & (POLICY_PSK | POLICY_OPENSSL))
+#endif
 		{
 		    loglog(RC_CLASH
 			, "authentication method disagrees with \"%s\", which is also for an unspecified peer"
@@ -553,6 +702,8 @@
 void
 add_connection(const struct whack_message *wm)
 {
+    bool success = TRUE;
+
     if (con_by_name(wm->name, FALSE) != NULL)
     {
 	loglog(RC_DUPNAME, "attempt to redefine connection \"%s\"", wm->name);
@@ -577,6 +728,15 @@
 	c->sa_rekey_fuzz = wm->sa_rekey_fuzz;
 	c->sa_keying_tries = wm->sa_keying_tries;
 
+	c->block_cypher = wm->block_cypher;
+
+#ifdef OPENSSL
+	c->this.id.key_id.len = 0;
+	c->that.id.key_id.len = 0;
+	c->this.id.der_asn1_dn.len = 0;
+	c->that.id.der_asn1_dn.len = 0;
+#endif
+
 	c->addr_family = wm->addr_family;
 	c->tunnel_addr_family = wm->tunnel_addr_family;
 
@@ -587,7 +747,7 @@
 	default_end(&c->that, &c->this.host_addr);
 
 	/* force any wildcard host IP address to that end */
-	if (isanyaddr(&wm->left.host_addr))
+	if (isanyaddr(&c->this.host_addr))
 	{
 	    struct end t = c->this;
 
@@ -595,16 +755,45 @@
 	    c->that = t;
 	}
 
+#ifdef OPENSSL
+	{
+	    int i;
+
+	    for(i=0; i<MAX_OTHER; i++) {
+	      c->other[i].cert = NULL;
+	      c->other[i].type = 0;
+	    }
+	}
+	load_cert_and_key(wm->whack_certfile, wm->whack_keyfile,
+	    (X509 **)&(c->cert), (EVP_PKEY **)&(c->key));
+	c->cert_options = parse_options(wm->whack_certopts);
+
+#if 0 /* to be removed? */
+	/* ID_DER_ASN1_DN cannot be done with path=db or path=dir */
+	if (! check_idtype_and_path(c, wm->whack_certpath)) {
+	  success = FALSE;
+	}
+#endif
+
+       if (! make_lookups((STACK_OF(XMAP) **)(&(c->lu)),
+         wm->whack_certpath) ) {
+         success = FALSE;
+       }
+       strncpy(c->path, wm->whack_certpath, PATH_NAME_LIMIT);
+#endif
+
+
+
 	/* set internal fields */
-	c->next = connections;
+	c->ac_next = connections;
 	connections = c;
 	c->interface = NULL;
-	c->routed = FALSE;
+	c->routing = RT_UNROUTED;
 	c->newest_isakmp_sa = SOS_NOBODY;
 	c->newest_ipsec_sa = SOS_NOBODY;
 	c->eroute_owner = SOS_NOBODY;
 
-	c->rw_state = rwcs_permanent;
+	c->kind = isanyaddr(&c->that.host_addr)? CK_TEMPLATE : CK_PERMANENT;
 
 #ifdef DEBUG
 	c->extra_debugging = wm->debugging;
@@ -614,11 +803,13 @@
 
 	unshare_connection_strings(c);
 
+	(void)orient(c);
 	connect_to_host_pair(c);
 
 	possibly_some_oppo = TRUE;	/* could be more careful about this */
 
-	/* log all about this connection */
+	/* log all about this connection, if sucessful */
+	if (success) {
 	log("added connection description \"%s\"", c->name);
 	DBG(DBG_CONTROL,
 	    char lhs[SUBNETTOT_BUF + ADDRTOT_BUF + IDTOA_BUF + ADDRTOT_BUF];
@@ -651,6 +842,15 @@
 		, (unsigned long) c->sa_keying_tries
 		, bitnamesof(sa_policy_bit_names, c->policy));
 	);
+	} else {
+	  loglog(RC_LOG_SERIOUS,
+	    "Adding connection description \"%s\" failed.",
+	    c->name);
+	  loglog(RC_LOG_SERIOUS,
+	    "Deleting connection description \"%s\".",
+	    c->name);
+	  delete_connection(c);
+	}
     }
 }
 
@@ -668,7 +868,7 @@
 {
     struct connection *d = clone_thing(*c, "temporary connection");
 
-    passert(c->rw_state == rwcs_permanent);
+    passert(c->kind == CK_TEMPLATE);
     if (his_id != NULL)
     {
 	passert(d->that.id.kind == ID_NONE || same_id(&d->that.id, his_id));
@@ -676,10 +876,9 @@
     }
     unshare_connection_strings(d);
 
-    d->rw_state = rwcs_instance;
+    d->kind = CK_INSTANCE;
 
     passert(oriented(*d));
-    passert(HasWildcardIP(*d));
     d->that.host_addr = *him;
     default_end(&d->that, &d->this.host_addr);
 
@@ -690,9 +889,9 @@
     default_end(&d->this, &d->that.host_addr);
 
     /* set internal fields */
-    d->next = connections;
+    d->ac_next = connections;
     connections = d;
-    d->routed = FALSE;
+    d->routing = RT_UNROUTED;
     d->newest_isakmp_sa = SOS_NOBODY;
     d->newest_ipsec_sa = SOS_NOBODY;
     d->eroute_owner = SOS_NOBODY;
@@ -772,21 +971,22 @@
  *   + that subnet contains peer_client (or peer is peer_client)
  *   + don't care about peer (we don't know), but not NO_IP
  *   + don't care about Phase 1 IDs (we don't know)
+ *   + require that the connection HAS_IPSEC_POLICY (duh: to serve clients)
  * Give preference to the first one that has an SA (either phase).
  */
-struct connection *
-find_opportunistic_connection(const ip_address *our_client, const ip_address *peer_client)
+static struct connection *
+find_connection_for_clients(const ip_address *our_client, const ip_address *peer_client)
 {
     struct connection *c = connections
 	, *best = NULL;
 
     passert(!isanyaddr(our_client) && !isanyaddr(peer_client));
 
-    for (c = connections; c != NULL; c = c->next)
-    {
-	if (oriented(*c) || orient(c, FALSE))
+    for (c = connections; c != NULL; c = c->ac_next)
 	{
-	    if (addrinsubnet(our_client, &c->this.client)
+       if (HAS_IPSEC_POLICY(c->policy)
+       && oriented(*c)
+       && addrinsubnet(our_client, &c->this.client)
 	    && addrinsubnet(peer_client, &c->that.client))
 	    {
 		best = c;
@@ -795,17 +995,17 @@
 		    break;
 	    }
 	}
-    }
     return best;
 }
 
 /* Find and instantiate a connection for an outgoing Opportunistic connection.
  * We've already discovered its gateway.
+ * We look for a the connection such that:
  *   + this is one of our interfaces
  *   + this subnet contains our_client (or we are our_client)
- *     (we will specialize the client)
- *   + that subnet is specified and is NO_IP/32 (we will fill in)
- *   + that peer is NO_IP (we will fill in)
+ *     (we will specialize the client).  We prefer the smallest such subnet.
+ *   + HasWildcardClient (that subnet is as NO_IP/32).
+ *   + that peer is NO_IP
  *   + don't care about Phase 1 IDs (probably should be default)
  * We could look for a connection that already had the desired peer
  * (rather than NO_IP) specified, but it doesn't seem worth the
@@ -816,9 +1016,13 @@
 , const ip_address *our_client, const ip_address *peer_client)
 {
     struct iface *p;
+    struct connection *best = NULL;
 
     passert(!isanyaddr(our_client) && !isanyaddr(peer_client));
 
+    /* We don't know his ID yet, so gw id must be an ipaddr */
+    passert(id_is_ipaddr(&gw->gw_id));
+
     /* for each of our addresses... */
     for (p = interfaces; p != NULL; p = p->next)
     {
@@ -829,28 +1033,22 @@
 	struct connection *c = find_host_pair_connections(&p->addr
 	    , pluto_port, (ip_address *)NULL, pluto_port);
 
-	for (; c != NULL; c = c->next)
-	{
-	    if (!oriented(*c))
-		(void)orient(c, TRUE);	/* needed by rw_instantiate */
-
-	    if (addrinsubnet(our_client, &c->this.client)
-	    && HasWildcardClient(c))
-	    {
-		/* success: instantiate.
-		 * We don't know his ID yet.
-		 */
-		return oppo_instantiate(c, &gw->gw, NULL, gw, our_client
-		    , peer_client);
-	    }
-	}
+       for (; c != NULL; c = c->hp_next)
+           if (c->kind == CK_TEMPLATE
+           && addrinsubnet(our_client, &c->this.client)
+           && HasWildcardClient(c)
+           && HAS_IPSEC_POLICY(c->policy)
+           && (best == NULL || !subnetinsubnet(&best->this.client, &c->this.client)))
+               best = c;
     }
-    return NULL;	/* no luck */
+    return best == NULL? NULL
+       : oppo_instantiate(best, &gw->gw_id.ip_addr, NULL, gw
+           , our_client, peer_client);
 }
 
 
 bool
-orient(struct connection *c, bool must)
+orient(struct connection *c)
 {
     if (!oriented(*c))
     {
@@ -871,10 +1069,11 @@
 		    {
 			if (c->interface == p)
 			    loglog(RC_LOG_SERIOUS
-				, "both sides of \"%s\" are our interfaces!"
-				, c->name);
+                               , "both sides of \"%s\" are our interface %s!"
+                               , c->name, p->rname);
 			else
-			    loglog(RC_LOG_SERIOUS, "two interfaces match \"%s\"", c->name);
+			    loglog(RC_LOG_SERIOUS, "two interfaces match \"%s\" (%s, %s)"
+                               , c->name, c->interface->rname, p->rname);
 			c->interface = NULL;	/* withdraw orientation */
 			return FALSE;
 		    }
@@ -886,7 +1085,11 @@
 		&& (!no_klips || c->that.host_port == pluto_port)))
 		    break;
 
-		/* swap ends and try again */
+		/* swap ends and try again.
+		 * It is a little tricky to see that this loop will stop.
+		 * Only continue if the far side matches.
+		 * If both sides match, there is an error-out.
+		 */
 		{
 		    struct end t = c->this;
 
@@ -895,14 +1098,8 @@
 		}
 	    }
 	}
-	if (!oriented(*c))
-	{
-	    if (must)
-		loglog(RC_LOG_SERIOUS, "cannot find interface for connection \"%s\"", c->name);
-	    return FALSE;
-	}
     }
-    return TRUE;
+    return oriented(*c);
 }
 
 void
@@ -913,13 +1110,13 @@
     if (c != NULL)
     {
 	SET_CUR_CONNECTION(c);
-	if (!orient(c, TRUE))
+	if (!oriented(*c))
 	{
-	    loglog(RC_ORIENT, "could not orient connection");
+		loglog(RC_ORIENT, "we have no ipsecN interface for either end of this connection");
 	}
-	else if (HasWildcardIP(*c))
+	else if (c->kind != CK_PERMANENT)
 	{
-	    loglog(RC_NOPEERIP, "cannot initiate connection without peer IP");
+		loglog(RC_NOPEERIP, "cannot initiate connection without knowing peer IP address");
 	}
 	else
 	{
@@ -928,11 +1125,7 @@
 	     * This is a fudge, but not yet important.
 	     * If we are to proceed asynchronously, whackfd will be NULL_FD.
 	     */
-	    ipsecdoi_initiate(whackfd
-		, c
-		, (c->policy>>POLICY_IPSEC_SHIFT) != 0
-		, c->policy
-		, 1);
+	    ipsecdoi_initiate(whackfd, c, c->policy, 1);
 	    whackfd = NULL_FD;	/* protect from close */
 	}
 	UNSET_CUR_CONNECTION();
@@ -944,12 +1137,12 @@
 /* knowing clients (single IP addresses), try to build an SA */
 void
 initiate_opportunistic(const ip_address *our_client
-, const ip_address *peer_client, int whackfd)
+, const ip_address *peer_client, bool held, int whackfd)
 {
     struct connection *c;
 
     /* What connection shall we use?
-     * First try for an existing one.
+     * First try for one that explicitly handles the clients.
      */
     DBG(DBG_CONTROL,
 	{
@@ -961,34 +1154,76 @@
 	    DBG_log("attempt opportunistic from %s to %s", ours, his);
 	});
 
-    c = find_opportunistic_connection(our_client, peer_client);
+    c = find_connection_for_clients(our_client, peer_client);
     if (c != NULL)
     {
+	/* We've found a connection that can serve.
+	 * Do we have to initiate it?
+	 * Not if there is currently an IPSEC SA.
+	 * But if there is an IPSEC SA, then KLIPS would not
+	 * have generated the acquire.  So we assume that there isn't one.
+	 * This may be redundant if a non-opportunistic
+	 * negotiation is already being attempted.
+	 */
+
 	/* We will only request an IPsec SA if policy isn't empty
 	 * (ignoring Main Mode items).
 	 * This is a fudge, but not yet important.
 	 * If we are to proceed asynchronously, whackfd will be NULL_FD.
 	 */
-	ipsecdoi_initiate(whackfd
-	    , c
-	    , (c->policy>>POLICY_IPSEC_SHIFT) != 0
-	    , c->policy
-	    , 1);
+
+	passert(HAS_IPSEC_POLICY(c->policy));
+
+	if (held)
+	{
+	    /* what should we do on failure? */
+	    (void) assign_hold(c, our_client, peer_client);
+
+	    switch (c->routing){
+	    case RT_UNROUTED:
+	        c->routing = RT_UNROUTED_HOLD;
+	        break;
+	    case RT_ROUTED_PROSPECTIVE:
+	        c->routing = RT_ROUTED_HOLD;
+	        break;
+	    default:
+	        passert(FALSE);
+	    }
+	}
+	ipsecdoi_initiate(whackfd, c, c->policy, 1);
 	whackfd = NULL_FD;	/* protect from close */
     }
     else
     {
-	/* try to find peer via DNS query */
-	err_t ugh = discover_gateway(peer_client);
+       /* No connection explicitly handles the clients.
+        * So we don't even know the peer:
+        * try to discover peer via DNS query
+        */
+       struct gw_info *gw;
+       err_t ugh = discover_gateway(peer_client, (const struct id *) NULL, &gw);
 
 	if (ugh != NULL)
 	{
-	    loglog(RC_OPPOFAILURE, "failure discovering gateway: %s", ugh);
+           char pcb[ADDRTOT_BUF];
+
+           addrtot(peer_client, 0, pcb, sizeof(pcb));
+           loglog(RC_OPPOFAILURE, "failure discovering gateway for %s: %s"
+               , pcb, ugh);
+
+           if (held)
+           {
+               /* Replace HOLD with PASS.
+                * The type of replacement *ought* to be
+                * specified by policy.
+                */
+               (void) replace_bare_shunt(our_client, peer_client
+                   , SPI_PASS  /* fail into PASS */
+                   , TRUE, "replace HOLD with PASS [no SG discoverd]");
+           }
 	}
 	else
 	{
-	    /* note: new gw_info is at front of gateways list */
-	    c = build_outgoing_opportunistic_connection(gateways, our_client
+	    c = build_outgoing_opportunistic_connection(gw, our_client
 		, peer_client);
 	    if (c == NULL)
 	    {
@@ -997,27 +1232,36 @@
 		    , pb[ADDRTOT_BUF];
 
 		addrtot(our_client, 0, ocb, sizeof(ocb));
-		addrtot(peer_client, 0, pcb, sizeof(ocb));
-		addrtot(&gateways->gw, 0, pb, sizeof(pb));
+		addrtot(peer_client, 0, pcb, sizeof(pcb));
+                passert(id_is_ipaddr(&gw->gw_id));
+                addrtot(&gw->gw_id.ip_addr, 0, pb, sizeof(pb));
 		loglog(RC_OPPOFAILURE
 		    , "no suitable connection for opportunism"
 		      " between %s and %s with %s as peer"
 		    , ocb, pcb, pb);
+
+                if (held)
+                {
+                    /* Replace HOLD with PASS.
+                     * The type of replacement *ought* to be
+                     * specified by policy.
+                     */
+                    (void) replace_bare_shunt(our_client, peer_client
+                        , SPI_PASS      /* fail into PASS */
+                        , TRUE, "replace HOLD with PASS [no suitable connection]");
+                }
 	    }
 	    else
 	    {
-		/* We will only request an IPsec SA if policy isn't empty
-		 * (ignoring Main Mode items).
-		 * This is a fudge, but not yet important.
-		 * If we are to proceed asynchronously, whackfd will be NULL_FD.
+                /* If we are to proceed asynchronously, whackfd will be NULL_FD.
 		 */
 		passert(c->gw_info != NULL);
+               passert(HAS_IPSEC_POLICY(c->policy));
+               passert(c->routing == RT_UNROUTED);
+               if (held)
+                   c->routing = RT_UNROUTED_HOLD;
 		c->gw_info->last_tried_time = now();
-		ipsecdoi_initiate(whackfd
-		    , c
-		    , (c->policy>>POLICY_IPSEC_SHIFT) != 0
-		    , c->policy
-		    , 1);
+		ipsecdoi_initiate(whackfd, c, c->policy, 1);
 		whackfd = NULL_FD;	/* protect from close */
 	    }
 	}
@@ -1035,7 +1279,7 @@
 
     for (c = con_by_name(nm, TRUE); c != NULL; c = n)
     {
-	n = c->next;	/* grab this before c might disappear */
+	n = c->ac_next;	/* grab this before c might disappear */
 	if (streq(c->name, nm))
 	{
 	    SET_CUR_CONNECTION(c);
